<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>Data Socket Test Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align=center>The Data Socket Test</H1>
        <h2>Test Objectives:</h2>
        <ul>
        <li>Exercise the data socket communication between two host on same or different platform, e.g. Linux-Linux, LInux-Sun</li>
        <li>Records the rate of sending data of various types and sizes of data in an ilwd</li>
        <li>Compares the current rate against past releases to check for performance improvement in the current software</li>
        </ul>
 
        <H2>Setup</H2>
        <ul>
        <li><P>Choose a directory to install the test scripts. On dev, the directory is /ldas_usr/ldas/test/datasock. The required files are:

        <P><CODE><font color='brown'>datasock_driver.tcl<BR>
        datasock_tester.tcl<BR>
        datasock_test.tcl<BR>
        datasock_stats.tcl<BR>
        datasock_hostfile<BR>
        rundatasock.tcl<BR>
        fmt_times.tcl<BR>
        LDASapi.rsc<BR>
        elementilwd.cc<BR>
        elementilwd.tcl<BR>
        hostfile_tclchannel</font>- editable configuration file which specifies which hosts are to be tested, and the data sizes and types that are to be sent
        <p><font color='brown'>Makefile</CODE></font>
        <P>Make sure all the .tcl files have execute permission.  Each host included in the test must have the test scripts installed on the system.  The path to the scripts must be the same on every host.  The most convenient way to accomplish this is to place the scripts on one host, and have that directory NFS mounted to the same path on the rest of the hosts.  The directory where the scripts are found can be passed to the driver script as an argument, or it can be specified in the configuration file.  See the following sections for more information.  The default directory is <CODE>/ldas_usr/ldas/test/datasock</CODE>.
        <li><u>Set up Environment variables for ssh into hosts</u>:<p>
		 Environment variable SSH_AUTH_SOCK is required to allow execution of scripts on different machines to retrieve logs.
		 To set this, on the ldas gateway, find out the name of the ldas agent by running the ldas utility ldasagent.
		 Then setenv SSH_AUTH_SOCK to the output of ldasagent if an agent exists. Example:
		 <pre><font color='blue'>
			ldasagent
			> /tmp/ssh-vWcN7555/agent.7555
			setenv SSH_AUTH_SOCK /tmp/ssh-vWcN7555/agent.7555
		</font></pre>
		 Then verify that the ssh environment variable setting works by ssh-ing into a server; you should be able to do so without 
		 entering a password. 
		</li> 		
        <li>ILWD files</li>
        <P>To create the ILWD files necessary for the test, create a subdirectory <CODE>ilwd</CODE>.  Move the files <CODE>elementilwd.cc</CODE>, <CODE>elementilwd.tcl</CODE>, and <CODE>Makefile</CODE> into the <CODE>ilwd</CODE> subdirectory.  Compile the <CODE>elementilwd</CODE> utility by typing <CODE>make elementilwd</CODE> at the command prompt.  Generate ILWD files by typing <CODE>elementilwd.tcl binary</CODE> at the command line.  This will create a subdirectory <CODE>binary</CODE> containing binary ILWD files.  If you want ascii ILWD files, type <CODE>elementilwd.tcl ascii</CODE> at the command prompt.  See the following section about how to specify which ILWD files are to be used during the test.

        <li>Edit Configuration file for hosts and ilwd dims</li>
        <P>The configuration file is a list of directives to the driver script.  The driver script performs each directive in sequential order, and completes each directive before moving on to the next.  Most of the directives are in the form of assignments, assigning a value to a variable.  The following is a list of valid directives:

        <P><TABLE border=1 cellspacing=0 cellpadding=10>
            <TR>
                <TD valign=top><CODE>samples=&lt;number&gt;</CODE>
                <TD>Number of samples sent and received for each type/dim pair before averaging the results.  (Default: 10)
            <TR>
                <TD valign=top><CODE>ilwdfmt=&lt;binary|ascii&gt;</CODE>
                <TD>ILWD data format. Valid values: binary, ascii  (Default: ascii)
            <TR>
                <TD valign=top><CODE>testdir=&lt;dirname&gt;</CODE>
                <TD>Test directory.  Directory where script files are installed.  (Default: /ldas_usr/ldas/test/datasock)
            <TR>
                <TD valign=top><CODE>thread=&lt;0|1&gt;</CODE>
                <TD>Use threaded or unthreaded calls. Valid values: 0, 1  (Default: 0)
            <TR>
                <TD valign=top><CODE>withcont=&lt;0|1&gt;</CODE>
                <TD>With or without ILWD container. Valid values: 0, 1  (Default: 1)
            <TR>
                <TD valign=top><CODE>types=&lt;all|types_list&gt;</CODE>
                <TD>ILWD types.  Valid values: all, char_s, char_u, int_2s, int_2u, int_4s, int_4u, int_8s, int_8u, real_4, real_8, lstring_2, lstring_4, lstring_8, lstring_16, complex_8, complex_16  (Default: all)
                <BR>The value "all" specifies all types.  If including multiple types, separate them with commas only.
            <TR>
                <TD valign=top><CODE>dims=&lt;all|dims_list&gt;</CODE>
                <TD>ILWD dimensions.  Valid values: all, 1, 10, 100, 1000, 10000, 100000, 1000000  (Default: all)
                <BR>The value "all" specifies all dims except for 1000000.  If including multiple types, seperate them with commas only.
            <TR>
                <TD valign=top><CODE>client=&lt;computer_name&gt;</CODE>
                <TD>Name of client computer which initiates the communication with the server. 
            <TR>
                <TD valign=top><CODE>server=&lt;computer_name&gt;</CODE>
                <TD>Name of server computer which receives the data from the client and sends it back.
            <TR>
                <TD valign=top><CODE>refresh</CODE>
                <TD>Directs the driver script to stop the test scripts on all previous client and server computers.  The test scripts will be started again the next time the computer name is assigned to the client or server variables.
            <TR>
                <TD valign=top><CODE>start &lt;computer_list&gt;</CODE>
                <TD>Directs the driver script to restart the test scripts on the specified computers.
        </TABLE>

        <P>There must not be any spaces surrounding the equal (=) sign of the assignments.  The <CODE>client=</CODE> and <CODE>server=</CODE> assignments must appear on the same line (separated by spaces).  All the other assignments can appear one or many per line, separated by spaces.  All assignments remain in effect until it is reassigned.  If a line starts with a hash (#), the rest of the line is treated as a comment.  When the driver script reaches a line with <CODE>client=</CODE> and <CODE>server=</CODE> assignments, it starts the communication test between the two specified computers.  The assignments that were specified before define the type of test between the two computers.

        <P>The <CODE>datasock_hostfile</CODE> file is a sample configuration file that includes tests for all types and dims, with and without container, and with and without threaded calls.  The client and server computer names are specific to our network.  They represent Linux and Solaris machines used to test the different combinations of communication: Linux-to-Solaris, Linux-to-Linux, Solaris-to-Solaris, and loopback tests for Linux and Solaris.  Modify the vaules to match your network setup.
        </ul>
        <H2>Test exceution</H2>
        From ldas gateway, ssh dataserver <p>
        
        <B>Usage:</B> <CODE>datasock_driver.tcl host_file [-ab] [-d dir]</CODE>
        <P>Type <CODE>datasock_driver.tcl datasock_hostfile</CODE>.  This will start the data-socket communication between the hosts specified in the configuration file.  Log files are written to the <CODE>logs</CODE> directory.  Status messages from the driver script are printed to the terminal.  Results from the tests are written to files in a results directory.  The name of the result directory is called <CODE>results-MMDD</CODE>, where MMDD is the month and day of the date the test was run.  If the test runs through midnight, the result files will be split between two result directories.  The result file names have the format client_server_.  <arguments> <separate 1000000>
        <p>To monitor progress, 
        <pre><font color='brown'>tail -f driver.log
        </pre></font>
        <H2>Test Validation</H2>
        <ul>
        <li>Formatting results<p>
        <B>Usage:</B> <CODE>fmt_times.tcl [files]</CODE>
        <P>The result files can be formatted into HTML and text reports, displaying tables of the result data.  To format the results, at the command prompt type <CODE>../fmt_times.tcl *</CODE> in the results directory.  Make sure all the result files for the particular test run are in one results-MMDD directory.  The formatting script will complain if any types or dims are missing for a client-server pair.  This can indicate that one of the tests did not succeed.  It may also indicate that a result file is missing and is actually residing in another directory.  This can happen if the tests ran through midnight.
        <P>The formatting script will produce three types of files for each client-server pair: .log, .txt, and .html.  The .log files are concatenations of result files with the same client-server pair.  The .log files are needed for comparing results with a previous run, described in the next section.  The .html files contain tables of the results in HTML format.  The .txt files contain tables of the results in text format.
        </li>
        <li>Comparing statistics with previous releases<p>
        <B>Usage:</B> <CODE>datasock_stats.tcl Current_files Previous_directory [-o]</CODE>
        <P>At the command prompt, type <CODE>datasock_stats.tcl *.log ../results-MMDD</CODE> (replace MMDD with the date you want to compare to).  There must be corresponding .log files in the results directory you want to compare to.  The stats script will produce a .stats file for each client-server pair.  Each .stats file contains the statistics of the result differences between the two test runs.  If the -o option is specified, an overall.stats file is written which contains the statistics over all client-server pairs.
        <p>Currently the datasock_driver.tcl script automatically compares the statistical comparison of current results with those of the 3 past releases. The output file <i>overall.stats</i> is moved
        into subdirectories 100, 110 and 120 for releases 1.0.0, 1.1.0 and 1.2.0 comparisions. 
        </ul>
    </BODY>
</HTML>
